!   input.f90      LINUX version
       Subroutine Input
!
       USE repsblock
       USE mapblock
!      USE curdblock
       USE fractblock
       USE specblock
       USE dstrb_blk

!  gans - answer: "output map?"
!  ians - answer: "input habitat optima?"
!  fract_ans - answer: "wrap fractal map?"
       character*1 ians, fract_ans, lans
       character*9 dates
       character*60 filename

!  nocurd - validity check on curdling
!      logical nocurd
!
       call date_and_time (dates)
       print 100, dates
       write (15,100) dates
100    format (/t10,'Competition Model',t60,a9/)
!
98     print 102
102    format (t10,'Enter map type to be analyzed:'/       &
   15x,'<I>  Input existing map file'/                     &
   15x,'<R>  Generate a random map (with replacement)'/    &
   15x,'<S>  Generate a simple random map'/                &
!  15x,'<C>  Generate a curdled (hierarchical) map'/       &
   15x,'<M>  Generate a multifractal random map'/          &
   15x,'<G>  Generate a multifractal randm map with a gradient'/)
       read (*,103) maptype
103    format (a1)
       print 104, maptype
       write (15,104) maptype
104    format (t10,'Map choice: ',a1)
!
!   maptype is the print of map to be generated
!      maptype = s       simple random map
!      maptype = r       random map without replacement
!      maptype = c       curdled map
!      maptype = m       multifractal map
!      maptype = g       multifractal map gradient
!      maptype = i       import data set
!
          if (maptype .eq. 's') maptype = 'S'
          if (maptype .eq. 'r') maptype = 'R'
          if (maptype .eq. 'm') maptype = 'M'
          if (maptype .eq. 'g') maptype = 'G'
!         if (maptype .eq. 'c') maptype = 'C'
          if (maptype .eq. 'i') maptype = 'I'
!
!      if (maptype .eq. 'R' .or. maptype .eq. 'C'           &
       if (maptype .eq. 'R'                                 &
          .or. maptype .eq. 'I' .or. maptype .eq. 'S'       &
          .or. maptype .eq. 'M' .or. maptype .eq. 'G') then
            goto 197
         else
            goto 98
       endif
197    continue
!
!..if map to be input then read 'mapfile'
       if (maptype .eq. 'I') then
          pr = 1.0
          print 105
105       format (t10,'Enter name of input map file')
          read (*,106) mapfile
106       format (a60)
          print 114, mapfile
          write (15,114) mapfile
114       format (t10,'Input map name: ',a60)
       endif
!
!..enter parameters for multifractal map
       if (maptype .eq. 'M' .or. maptype .eq. 'G') then
          sigma = 1.0
1901      print 2201
2201      format (t10,'Enter the number of levels and H ')
!         read *, maxlevel, H, sigma
          read *, maxlevel, H
          print 2202, maxlevel, H
          write (15,2202) maxlevel, H
2202      format (t10,'Maxlevel ',i5,2x,' H = ',g12.6)
          N = 2**maxlevel
          if (N .gt. maxprm) then
            print *,'  Number of levels is too large'
            goto 1901
          endif
          if (H .lt. 0.0 .or. H .gt. 1.0) GOTO 1901
          irow = N
          jcol = N
          print 101, irow, jcol
          write (15,101) irow, jcol
          print 1902
1902      format (t10,'Wrap map? ')
          read (*,103) fract_ans
          wrap = .false.
          if (fract_ans .eq. 'y' .or. fract_ans .eq. 'Y') wrap = .true.
          print 1911, fract_ans, wrap
          write (15,1931) wrap
1911      format (t10,a1,'  Wrap = ',l1)
1931      format (t10,'  Wrap = ',l1)
       endif
!
       if (maptype .eq. 'G') then
          print 1850
1850      format (t10,'Gradient fractal: Initialize four map corners ')
          read *, northeast
          print 1851, northeast
          write (15,1851) northeast
1851      format (5x,g12.6)
          read *, southeast
          print 1851, southeast
          write (15,1851) southeast
          read *, southwest
          print 1851, southwest
          write (15,1851) southwest
          read *, northwest
          print 1851, northwest
          write (15,1851) northwest
       endif
!
!..iseed is random number seed
       iseed = -112773941
       maxrow = maxprm
       maxcol = maxprm
!
       if (maptype .ne. 'M' .and. maptype .ne. 'G') then
99        print 192
192       format (t10,'Enter the number of map rows and columns ')
          read *, irow, jcol
          if (irow .gt. maxrow .or. jcol .gt. maxcol) goto 99
          print 101, irow, jcol
          write (15,101) irow, jcol
101       format(t10,'Rows x Columns = ',i6,' x ',i6)
       endif
!
!..enter parameters for curdled maps
!      if (maptype .eq. 'C') then
!321       CONTINUE
!         print 107
107       format (t10,'Enter the number of curdling levels ')
!         read *, icasno
!         if (icasno .le. 0 .or. icasno .gt. maxcurd) GOTO 321
!
!         il = 1
!         print 108
108       format (t10,'Enter NUMBER of cells and P for each level ')
!         nocurd = .false.
!         do ijk = 1, icasno
!           read *, ncas(ijk), pcas(ijk)
!           if (ncas(ijk) .gt. maxcurd) nocurd = .true.
!           il = il*ncas(ijk)
!         enddo
!         if (nocurd) GOTO 321
!         print 109, icasno
!         write (15,109) icasno
109       format (t10,'Curds (levels =',i2,') N      P ')
!         pmap = 1.0
!         do ijk = 1, icasno
!           pmap = pmap * pcas(ijk)
!           print 110, ncas(ijk), pcas(ijk)
!           write (15,110) ncas(ijk), pcas(ijk)
110         format (24x,i6,3x,g12.6,2x,g12.6)
!         enddo
!
!..calculate Pmap -- the totals
!            pmap = pcas(1) * pcas(2) * pcas(3)      &
!   + pcas(1) * (1.0 - pcas(2)) * qcas(3)            &
!   + (1.0 - pcas(1)) * qcas(2) * pcas(3)            &
!   + (1.0 - pcas(1)) * (1.0 - qcas(2)) * qcas(3)

!           print 111,il,pmap
!           write (15,111) il, pmap
111         format (t10,'Geo. Totals',3x,i6,3x,g12.6)
!
!         if (il .ne. irow .or. pmap .eq. 0.0 .or. pmap .gt. 1.0) &
!   goto 321
!      endif
!
!  input random number seed
       print 115
115    format (t10,'Enter a negative random number seed ')
       read *,  iseed
       print 116, iseed
       if (iseed .gt. 0) iseed = -iseed
       write (15,116) iseed
116    format (t10,'Random number seed: ',i10)
!  save separate seeds for map generation, disturbance and movement
       iseed_map = iseed
       iseed_dstb = iseed
       iseed_mov = iseed
!
!..set up multiple habitats
95     print 203
203    format (t10,'Enter the number of map classes ')
       read *, ihab
       if (ihab .lt. 0) goto 95
       print 204, ihab
       write (15,204) ihab
204    format (t10,'Map classes = ',i6)
! allocate p vector
       ALLOCATE (p(0:ihab))

!
!..obtain probabilities for the 'ihab' habitat types
       if (maptype .ne. 'I' .and. maptype .ne. 'C') then
          psum = 0.0
          do i = 0,ihab
199         print 215, i
215         format (t10,'Type in the ',i3,'th probability ')
            read *, tmp
            print *, tmp
            psum = psum + tmp
            p(i) = psum
            if (p(i) .lt. 0.0) goto 199
          enddo
          pr = 0.0
          do i = 0,ihab
            p(i) = p(i)/psum
            print 206, i, p(i)
            write (15,206) i, p(i)
206         format (15x,'p(',i2,') = ',f8.4)
          enddo
          pr = p(ihab) - p(0)
       endif
!..print warning if the number of habitats is greater than 1 and the
!..maptype is curdled
       if (ihab .gt. 1 .and. maptype .eq. 'C') &
           print 207
207        format (t10,'WARNING: Curdled maps can not use multiple habitats')
!
       print 300
300    format (t10,'Enter the number of replications ')
       read *, nrep
       print 301, nrep
       write (15,331) nrep
301    format (t10,i10)
331    format (t10,'Replications = ',i10)
!
92     print 302
302    format (t10,'Enter the number of years per simulation ')
       read *, simlen
       if (simlen .lt. 1.0) goto 92
       print 303, simlen
       write (15,333) simlen
303    format (t10,i10)
333    format (t10,'Simulation years = ',i10)
!
97     print 129
129    format (t10,'Enter the number of species types ')
       read *, ispecies
       if (ispecies .lt. 0 ) goto 97
       print 304, ihab, ispecies
       write (15,334) ihab, ispecies
304    format (t10, 2i10)
334    format (t10,'Habitats = ',i4,' Species no. = ',i4)
!
!   input species seed competition matrix
       open (19, file='habitat.opt',status='unknown')
       PRINT 305
305    format (t10,'Read species optima from habitat.opt file? ')
       READ (*,103) ians
       if (ians .eq. 'y' .or. ians .eq. 'Y') then
          read (19,*) ((iopt(i,j), j=1,ihab), i=1,ispecies)
        else
          print 306
306       format (t10,'Enter the seed competition matrix ')
          read *, ((iopt(i,j), j=1,ihab), i=1,ispecies)
          print 307
          write (15,307)
307       format (t10,'Seed production matrix (Rows = Species)')
          do i = 1, ispecies
             print 308, i,(iopt(i,j),j=1,ihab)
             write (15,308) i,(iopt(i,j),j=1,ihab)
308          format (t10,i3,':',10i5)
          enddo
          write (19,*) ((iopt(i,j), j=1,ihab), i=1,ispecies)
          close(19)
       end if
!
       print 309
309    format (t10,'Input 2 lines for each species: '    /&
               t15,'(1) life-form, disperse function'    /&
               t15,'(2) mean, max dispersal, fecundity, seed rain, disturbance threshold' )

       do i = 1, ispecies
!          read (*,213) life_form(i), dc(i)
213       format (a1,1x,a1)
          read *, life_form(i), dc(i)
            life_form(0) = ' '
            if (life_form(i) .eq. 'a') life_form(i) = 'A'
            if (life_form(i) .eq. 'b') life_form(i) = 'B'
            if (life_form(i) .eq. 'p') life_form(i) = 'P'
            if (life_form(i) .eq. 'l') life_form(i) = 'L'

            if (dc(i) .eq. 'n') dc(i) = 'N'
            if (dc(i) .eq. 'u') dc(i) = 'U'
            if (dc(i) .eq. 'e') dc(i) = 'E'
            if (dc(i) .eq. 'd') dc(i) = 'D'
            if (dc(i) .eq. 'c') dc(i) = 'C'
!  read mean, max dispersal, fecundity and seed rain threshold
          read *, xbar(i), rdst(i), fecund(i), sd_rain(i), d_slop(i)
!            if (rdst(i) .gt. xbar(i)) rdst(i) = xbar(i)
            if (dc(i) .eq. 'N') rdst(i) = xbar(i)
            sd(i) = 0.0
            if (dc(i) .eq. 'N') sd(i) = (rdst(i) - xbar(i)) / 3.0
            if (dc(i) .eq. 'E') sd(i) = rdst(i) / 3.0
       enddo
!
       print 312
       write (15,312)
312   format (t2,'Sp#    Fecund  Life D-type   Mean      SD       ', &
                       'Max Dist SdRnThres DisSlope')

       do i = 1, ispecies
          print 313,     i, fecund(i), life_form(i), dc(i), xbar(i), sd(i), rdst(i), &
				sd_rain(i),d_slop(i)
          write (15,313) i, fecund(i), life_form(i), dc(i), xbar(i), sd(i), rdst(i), &
          			sd_rain(i),d_slop(i)
313       format (t2,i3,2x,f8.4,4x,a1,5x,a1,5(2x,f8.4))
       enddo
!
!  input species/habitat mortality matrix
!       print 314
!314    format (t10,'Enter the species-habitat mortality matrix ')
!       read *, ((shmort(i,j), j=1,ihab), i=1,ispecies)
!       print 315
!       write (15,315)
!315    format (t10,'Species-habitat mortality matrix (Rows = Species)')
!       do i = 1, ispecies
!          print 316, i,(shmort(i,j),j=1,ihab)
!          write (15,316) i,(shmort(i,j),j=1,ihab)
!316       format (t10,i3,':',6g12.6)
!       enddo

!  select disturbance type
       PRINT 315
315    FORMAT (t10,'Input disturbance type <F,S,R,W,B or N> ')
       read 103, freq_type
       select case (freq_type)
           case ('f')
              freq_type = 'F'
           case ('s')
              freq_type = 'S'
           case ('r')
              freq_type = 'R'
           case ('w')
              freq_type = 'W'
           case ('b')
              freq_type = 'B'
           case default
              freq_type = 'N'
       end select
       print *, freq_type
       write (15,316) freq_type
316    format (t10,'Disturbance frequency type is ',a1)
       PRINT 416
416    format (t10,'Input maximum disturbance severity index ')
       read *, max_sevr
       PRINT 417, max_sevr
417    format (t10,'Maximum disturbance severity index = ',i4)
       write (15,417) max_sevr

!  select fraction of map disturbed per year and proportion of years disturbed
       select case (freq_type)
          case ('F','S','R','W','B')
             PRINT 317
317          format (t10,'Input fraction of map to be disturbed per year ')
             READ *, fract_per_yr
             write (15,318) fract_per_yr
             print *, fract_per_yr
318          format (t10,'Fraction of map to be disturbed per year ',f6.4)
!  estimate minimum disturbance per year

             PRINT 319
319          FORMAT (t10,'Input fraction of years to be disturbed ')
             READ *, fract_years
             if (fract_years .lt. fract_per_yr) fract_years = fract_per_yr
             print *, fract_years
             write (15,349) fract_years
349          format (t10,'Fraction of years to be disturbed ',f6.4)
          case default
       END select

!  select disturbance duration and variability
       select case (freq_type)
          case ('F','S')
              PRINT 320
320           format (t10,'Input duration of disturbance: ')
              READ *, idur
              print *, idur
              write (15,341) idur
341           format (t10,'Duration of disturbance: ',i4)


              PRINT 325
325           format (t10,'Input CV for disturbance variability: ')
              read *, dcv
              print *, dcv
              write (15,326) dcv
326           format (t10,'CV for disturbances: ',f6.4)
          case ('W')
              PRINT 325
              read *, dcv
              print *, dcv
              write (15,326) dcv
          case ('B')
              PRINT 323
323           format (t10,'Input the value of dH: ')
              READ *, dH
              print *, dH
              write (15,324) dH
324           format (t10,'Value of dH: ',f6.4)

              PRINT 325
              read *, dcv
              print *, dcv
              write (15,326) dcv

          case default
       END select

!  select spatial distribution of disturbance
       select case (freq_type)
          case ('F','S','R','W','B')
             print 339
339          format (t10,'Enter spatial distribution of disturbance <R,C>' )
             READ 103, d_type
             PRINT 351, d_type
             write (15,351) d_type
351          format (t10,'Disturbance distribution type: ',a1)
          select case (d_type)
             case ('C','c')
96              PRINT 352
352             format (t10,'Enter probability of cluster growth <0.0--1.0> ')
                if (px .gt. 1.0 .or. px .lt. 0.0) GOTO 96
                READ *, px
                PRINT *, px
                write (15,353) px
353             format (t10,'Probability for cluster growth is ',f6.4)
             case default
                PRINT 354
354             format (t10,'Distribution type set to <R>')
                d_type = 'R'
          end select

          case default
       end select

4001   print 400
400    format (t10,'Initialize species distributions: '/ &
        t12,'<O>ptimum, <R>andom, <E>nd Random Edge, <L>ine, or <H>alf  ')
       read (*,212) mapinit
          select case (mapinit)
              case ('O','o')
                write (15,431)
431             format (t10,'Initial species distribution: optimum')
              case ('R','r')
                mapinit = 'R'
                write (15,432)
432             format (t10,'Species distribution: random')
              case ('E','e')
                mapinit = 'E'
                write (15,433)
433             format (t10,'Species distribution: edge')
              case ('H','h')
                mapinit = 'H'
                write (15,434)
434             format (t10,'Species distribution: half')
              case ('L','l')
                mapinit = 'L'
                write (15,435)
435             format (t10,'Species randomly distributed on edge' )
              case default
                GOTO 4001
          end select
          print 401, mapinit

!  boundaries -- wrapped, reflecting, or absorbing
4002   PRINT 507
507    format (t10,'<W>rapped, <R>eflecting or <A>sorbing boundaries? ')
       read (*,212) movtype
          if (movtype .eq. 'w') movtype = 'W'
          if (movtype .eq. 'r') movtype = 'R'
          if (movtype .eq. 'a') movtype = 'A'
          if (movtype .eq. 'W') write (15,231)
          if (movtype .eq. 'R') write (15,232)
          if (movtype .eq. 'A') write (15,233)
231       format (t10,'Boundaries are wrapped')
232       format (t10,'Boundaries are reflecting')
233       format (t10,'Boundaries are absorbing')
!
       if (movtype .ne. 'A' .and. movtype .ne. 'R' .and. &
          movtype .ne. 'W') GOTO 4002
       PRINT 401, movtype
!
!  create an output map file
       print 504
504    format (t10,'Create an output map?  ')
       read (*,212) gans
212    format (a1)
       if (gans .eq. 'y' .or. gans .eq. 'Y') gans = 'Y'
       print 401, gans
401    format (t10,a1)
       outfile = ' '
       if (gans .eq. 'Y') then
          print 505
!          write (15,505)
505       format (t10,'Name of output map file?  ')
          read (*,106) outfile
          print 506, outfile
          write (15,506) outfile
506       format (t10,'Output species map in file: ',a40)
       endif
!
!  input name of file for writting species movement data
       print 600
600    format (t10,'Name of the file for species movement data? ')
       read 601, filename
601    format (a60)
       print 2200, filename
       write (15,2230) filename
2200   format (t10,a60)
2230   format (t10,'Species movement data in file: ',a40)
       open (11, file=filename,status='unknown')

!  set extinction switch
       PRINT 2204
2204   format (t10,'Check for species extinctions <y,n>? ')
       read (5,103) exans
       PRINT 2205, exans
       write (15, 2205) exans
2205   format (t10,'Species extinction check = ',a1)

!  open output map file
       if (outfile .ne. ' ') open (13, FILE= outfile, STATUS='unknown')
!
       return
       end

       subroutine Prog_Cntrl (pctl)
!
       USE repsblock
       USE specblock
       USE dstrb_blk

       CHARACTER*2 pctl
       INTEGER ispno, icpopt
       REAL value

       pctl = 'CP'
       do WHILE (pctl .eq. 'CP')
          PRINT 100
100       format (t10,'Input program control: go, cp or stop')
          read 101, pctl
101       format (a2)

          select case (pctl)
             case ('go')
               pctl = 'GO'
             case ('cp')
               pctl = 'CP'
             case ('st')
               pctl = 'ST'
             case default
          END select

          PRINT 102, pctl
          write (15,102) pctl
102       format (//t10,'Program control: ',a2)

          select case (pctl)
              case ('CP')
              PRINT 103
103           format (t10,'Options for changing species parameters: ' / &
                      t15,'    1.  fecundity' / &
                      t15,'    2.  mean dispersal' / &
                      t15,'    3.  seed rain threshold')
              PRINT 104
104           format (t10,'Enter species number, change option, and new value ')
              read *, ispno, icpopt, value

              select case (icpopt)
                  case (1)
                    fecund(ispno) = value
                    PRINT 105, ispno, value
                    write (15,105) ispno, value
105                 format (t10,'Species: ',i3,' Fecundity: ',g12.6)
                  case (2)
                    xbar(ispno) = value
                    if (rdst(ispno) .gt. xbar(ispno)) rdst(ispno) = xbar(ispno)
                    if (dc(ispno) .eq. 'N') rdst(ispno) = xbar(ispno)
                    sd(ispno) = 0.0
                    if (dc(ispno) .eq. 'N') sd(ispno) = (rdst(ispno) - xbar(ispno)) / 3.0
                    if (dc(ispno) .eq. 'E') sd(ispno) = rdst(ispno) / 3.0

                    PRINT 106, ispno, value
106                 FORMAT (t10,'Speices: ',i3,' Mean dispersal: ',g12.6)
                    write (15,106) ispno, value
                  case (3)
                    sd_rain(ispno) = value
                    PRINT *, '  Seed rain threshold changed '
                    PRINT 107, ispno, value
107                 format (t10,'Species: ',i3,' Seed rain: ',g12.6)
                    write (15,107) ispno, value
! 
                  case default
                    PRINT *, '  No changes made '
              end select

              case default
          end select
       END do
       return

       end subroutine
