!
       Subroutine sizeit

       USE repsblock
       USE mapblock
       USE specblock
       USE fractblock
!      USE curdblock
       USE dstrb_blk

       INTEGER msize, bsize

       msize = INT(SQRT(REAL((irow+2)*(jcol+2)))*10)
       bsize = (irow+2)*(jcol+2)
!
! mapblock variables
       ALLOCATE (map_hab(irow+2,jcol+2))
       ALLOCATE (map_sp(irow+2,jcol+2))
       ALLOCATE (iwk(irow+2,jcol+2))
       if (maptype .eq. 'R') THEN
         ALLOCATE (indx(bsize))  ! for sampling without replacement
        else
         ALLOCATE (indx(msize))
       endif
!  dstrb_blk
       ALLOCATE (istack(bsize))
       ALLOCATE (jstack(bsize))
! specblock variables
       ALLOCATE (ncnt(msize))
       ALLOCATE (is(ispecies,msize))
       ALLOCATE (js(ispecies,msize))
       ALLOCATE (dfun(ispecies,msize))
! fractal map generation
       if (maptype .eq. 'M' .or. maptype .eq. 'G') then
          ALLOCATE (cfd(bsize))
          ALLOCATE (kknt(0:ihab))
          ALLOCATE (xcrit(0:ihab))
          ALLOCATE (Xh(0:irow+2,0:jcol+2))
       ENDIF
! disturbance map
       if (freq_type .ne. 'N') then
          ALLOCATE (dstb_map(irow+1,jcol+2))
          dstb_map = 0
       end if
! curdblock variables
!      IF (maptype .eq. 'C') then
!        ALLOCATE (isl(icasno))
!        ALLOCATE (jsl(icasno))
!        ALLOCATE (mat(MAXVAL(ncas),MAXVAL(ncas)))
!        ALLOCATE (icdx(maxcurd*maxcurd))
!      end if

       return
       end

       SUBROUTINE Downsize

       USE repsblock
       USE mapblock
       USE specblock
       USE fractblock
!      USE curdblock
       USE dstrb_blk

! repsblock variables
       deALLOCATE (p)
!
! mapblock variables
       deALLOCATE (map_hab)
       deALLOCATE (map_sp)
       deALLOCATE (iwk)
!  dstrb_blk
       deALLOCATE (istack)
       deALLOCATE (jstack)

! specblock variables
       deALLOCATE (ncnt)
       deALLOCATE (is)
       deALLOCATE (js)
       deALLOCATE (dfun)
! disturbance map
       if (freq_type .ne. 'N') then
          deALLOCATE (dstb_map)
       end if
! curdblock variables
!      IF (maptype .eq. 'C') then
!        deALLOCATE (isl)
!        deALLOCATE (jsl)
!        deALLOCATE (mat)
!        deALLOCATE (indx)
!      end if
! fractal map generation
       if (maptype .eq. 'M' .or. maptype .eq. 'G') then
          deallocate (cfd)
          deallocate (kknt)
          deallocate (xcrit)
          deallocate (Xh)
       ENDIF

       return
       end
